package org.artifactory.repo;

import org.apache.http.HttpRequest;
import org.apache.http.HttpResponse;
import org.apache.http.ProtocolException;
import org.apache.http.RequestLine;
import org.apache.http.StatusLine;
import org.testng.annotations.Test;

import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;
import static org.testng.Assert.assertTrue;

@Test
public class JFrogRedirectStrategyTest {

    private static final int REDIRECT_PERMANENTLY = 308;

    @Test
    void testRedirectedPermanently() throws ProtocolException {
        HttpRequest request = mock(HttpRequest.class);
        HttpResponse response = mock(HttpResponse.class);
        StatusLine statusLine = mock(StatusLine.class);
        RequestLine requestLine = mock(RequestLine.class);
        when(statusLine.getStatusCode()).thenReturn(REDIRECT_PERMANENTLY);
        when(response.getStatusLine()).thenReturn(statusLine);
        when(request.getRequestLine()).thenReturn(requestLine);
        when(requestLine.getMethod()).thenReturn("GET");
        JFrogRedirectStrategy jFrogRedirectStrategy = new JFrogRedirectStrategy();
        assertTrue(jFrogRedirectStrategy.isRedirected(request, response, null));
    }
}