package org.artifactory.version.converter.v312;

import org.artifactory.version.converter.v160.AddonsLayoutConverterTestBase;
import org.jdom2.Document;
import org.jdom2.Element;
import org.jdom2.Namespace;
import org.testng.annotations.Test;

import static org.testng.Assert.assertEquals;

/**
 * @author Volodymyr Shulga
 */
@Test
public class AddBasicAuthenticationEnabledConverterTest extends AddonsLayoutConverterTestBase {
    private final AddBasicAuthenticationEnabledConverter converter = new AddBasicAuthenticationEnabledConverter();

    @Test
    public void testConvertWithAddingBaseAuth() throws Exception {
        String CONFIG_XML = "/config/test/config.3.1.3_add_basic_auth.xml";
        Document document = convertXml(CONFIG_XML, converter);
        Element root = document.getRootElement();
        Namespace ns = root.getNamespace();
        Element security = root.getChild("security", ns);
        // added new field with default value true.
        assertEquals(security.getChild("basicAuthEnabled", ns).getValue(), "true");
    }

    @Test
    public void testConvertWithoutAddingBaseAuth() throws Exception {
        String CONFIG_XML = "/config/test/config.3.1.3_with_basic_auth.xml";
        Document document = convertXml(CONFIG_XML, converter);
        Element root = document.getRootElement();
        Namespace ns = root.getNamespace();
        Element security = root.getChild("security", ns);
        // existing field not rewritten.
        assertEquals(security.getChild("basicAuthEnabled", ns).getValue(), "false");
    }
}