:: Get home location of the product
pushd %~dp0..
set ARTIFACTORY_BIN_DIR=%CD%
cd %ARTIFACTORY_BIN_DIR%..\..
set JF_PRODUCT_HOME=%CD%
popd

:: Set system.yaml related details
set JF_SYSTEM_YAML=%JF_PRODUCT_HOME%\var\etc\system.yaml
set YQ_PATH=%JF_PRODUCT_HOME%\app\third-party\yq

:: This will set any extra java options in EXTRA_JAVA_OPTIONS passed through system.yaml
call %~dp0\artifactoryCommon.bat :setExtraJavaOpts

:: Environment variables to be passed to tomcat
set CATALINA_HOME=%JF_PRODUCT_HOME%\app\artifactory\tomcat

set JAVA_OPTIONS=-server -Xms512m -Xmx2g -Xss256k -XX:+UseG1GC
set JAVA_OPTIONS=%JAVA_OPTIONS% --add-opens java.base/java.util=ALL-UNNAMED --add-opens java.base/java.lang.reflect=ALL-UNNAMED --add-opens java.base/java.lang.invoke=ALL-UNNAMED --add-opens java.base/java.text=ALL-UNNAMED --add-opens java.base/java.nio=ALL-UNNAMED --add-opens java.desktop/java.awt.font=ALL-UNNAMED
set JAVA_OPTIONS=%JAVA_OPTIONS% -Dfile.encoding=UTF8 -Djruby.compile.invokedynamic=false -Djruby.bytecode.version=1.8
set JAVA_OPTIONS=%JAVA_OPTIONS% -Dartdist=zip -Djf.product.home=%JF_PRODUCT_HOME%

:: This will remove duplicate java options in JAVA_OPTIONS
call %~dp0\artifactoryCommon.bat :removeDuplicateJavaOptions "%JAVA_OPTIONS%" "%EXTRA_JAVA_OPTIONS%"

if not ["%UNIQUE_DEFAULT_JAVA_OPTIONS%"] == [""] (
    set JAVA_OPTIONS=%UNIQUE_DEFAULT_JAVA_OPTIONS%
)

set JAVA_OPTIONS=%JAVA_OPTIONS% %EXTRA_JAVA_OPTIONS%

set CATALINA_OPTS=%JAVA_OPTIONS% -Dorg.apache.tomcat.util.buf.UDecoder.ALLOW_ENCODED_SLASH=true

:: Use custom java home if provided 
:: This will set JAVA_HOME
call %~dp0\artifactoryCommon.bat :setJavaHome
set JRE_HOME=%JAVA_HOME%

:: Add any property which needs to be picked by tomcat stop action
set JAVA_OPTS=-Djf.product.home=%JF_PRODUCT_HOME%
